lkml.org 
[lkml]   [2022]   [Mar]   [7]   [last100]   RSS Feed
Views: [wrap][no wrap]   [headers]  [forward] 
 
Messages in this thread
/
Date
From
SubjectRe: [PATCH bpf-next v4 6/8] compiler_types.h: Add unified __diag_ignore_all for GCC/LLVM
On Tue, Mar 08, 2022 at 01:00:18AM IST, Nick Desaulniers wrote:
> On Sat, Mar 05, 2022 at 04:16:43AM +0530, Kumar Kartikeya Dwivedi wrote:
> > Add a __diag_ignore_all macro, to ignore warnings for both GCC and LLVM,
> > without having to specify the compiler type and version. By default, GCC
> > 8 and clang 11 are used. This will be used by bpf subsystem to ignore
> > -Wmissing-prototypes warning for functions that are meant to be global
> > functions so that they are in vmlinux BTF, but don't have a prototype.
> >
> > Cc: linux-kernel@vger.kernel.org
> > Signed-off-by: Kumar Kartikeya Dwivedi <memxor@gmail.com>
> > ---
> > include/linux/compiler-clang.h | 3 +++
> > include/linux/compiler-gcc.h | 3 +++
> > include/linux/compiler_types.h | 4 ++++
> > 3 files changed, 10 insertions(+)
> >
> > diff --git a/include/linux/compiler-clang.h b/include/linux/compiler-clang.h
> > index f1aa41d520bd..babb1347148c 100644
> > --- a/include/linux/compiler-clang.h
> > +++ b/include/linux/compiler-clang.h
> > @@ -90,3 +90,6 @@
> > #else
> > #define __diag_clang_11(s)
> > #endif
> > +
> > +#define __diag_ignore_all(option, comment) \
> > + __diag_clang(11, ignore, option)
> > diff --git a/include/linux/compiler-gcc.h b/include/linux/compiler-gcc.h
> > index ccbbd31b3aae..d364c98a4a80 100644
> > --- a/include/linux/compiler-gcc.h
> > +++ b/include/linux/compiler-gcc.h
> > @@ -151,6 +151,9 @@
> > #define __diag_GCC_8(s)
> > #endif
> >
> > +#define __diag_ignore_all(option, comment) \
> > + __diag_GCC(8, ignore, option)
>
> While this approach will work for clang, it doesn't seem scalable for
> GCC. Documentation/process/changes.rst documents that we support gcc
> 5.1+. This approach will only disable diagnostics for gcc 8+.
>

ISTM the original commit adding these macros only defined them for GCC 8+, so
coverage for previous versions is already not there, unrelated to this change.
I am not sure what the reason for that was, though.

> > +
> > /*
> > * Prior to 9.1, -Wno-alloc-size-larger-than (and therefore the "alloc_size"
> > * attribute) do not work, and must be disabled.
> > diff --git a/include/linux/compiler_types.h b/include/linux/compiler_types.h
> > index 3f31ff400432..8e5d2f50f951 100644
> > --- a/include/linux/compiler_types.h
> > +++ b/include/linux/compiler_types.h
> > @@ -371,4 +371,8 @@ struct ftrace_likely_data {
> > #define __diag_error(compiler, version, option, comment) \
> > __diag_ ## compiler(version, error, option)
> >
> > +#ifndef __diag_ignore_all
> > +#define __diag_ignore_all(option, comment)
> > +#endif
> > +
> > #endif /* __LINUX_COMPILER_TYPES_H */
> > --
> > 2.35.1
> >

--
Kartikeya

\
 
 \ /
  Last update: 2022-03-07 21:57    [W:0.032 / U:0.340 seconds]
©2003-2020 Jasper Spaans|hosted at Digital Ocean and TransIP|Read the blog|Advertise on this site